> ## Documentation Index
> Fetch the complete documentation index at: https://docs.pipevest.com/llms.txt
> Use this file to discover all available pages before exploring further.

# Updates Portfolio

> Updates an investment portfolio



## OpenAPI

````yaml PUT /portfolio
openapi: 3.0.0
info:
  title: Pipevest Investment API
  description: Connecting millions of Africans to the global economy
  version: 0.0.1
servers:
  - url: https://api.pipevest.com/v1
    description: Production server
  - url: https://api.staging.pipevest.com/v1
    description: Staging server
security:
  - BearerAuth: []
paths:
  /portfolio:
    parameters:
      - $ref: '#/components/parameters/Signature'
      - $ref: '#/components/parameters/SignatureInput'
      - $ref: '#/components/parameters/XCliendId'
    put:
      tags:
        - Requests
      summary: Updates a portfolio
      parameters:
        - $ref: '#/components/parameters/ContentDigest'
        - $ref: '#/components/parameters/XIdempotencyKey'
      requestBody:
        required: true
        content:
          application/json:
            schema:
              $ref: '#/components/schemas/UpdatePortfolio'
      responses:
        '200':
          description: Details of a updated investment portfolio
          content:
            application/json:
              schema:
                allOf:
                  - $ref: '#/components/schemas/Success'
                  - type: object
                    properties:
                      data:
                        $ref: '#/components/schemas/Portfolio'
        '401':
          $ref: '#/components/responses/Unauthorized'
        '404':
          $ref: '#/components/responses/NotFound'
components:
  parameters:
    Signature:
      in: header
      name: Signature
      schema:
        type: string
        example: 'sig1=:OTEyMjY4...A5NTNDMEQ=:'
        description: >
          Base64 encoded signed hash of the http message request components.


          [Learn how signatures
          work](/concepts/http-signature/message-signature)
      required: true
    SignatureInput:
      in: header
      name: Signature-Input
      schema:
        type: string
        example: sig1=("Content-Type" "Content-Digest"...expires=<expires>
        description: >
          An ordered list of components that make up the signature base. It is
          used to recompute and verify the `Signature`


          [Learn how signatures
          work](/concepts/http-signature/message-signature)
      required: true
    XCliendId:
      in: header
      name: X-Client-Id
      schema:
        $ref: '#/components/schemas/ClientId'
      example: client-id
      required: true
    ContentDigest:
      in: header
      name: Content-Digest
      schema:
        type: string
        example: 'sha-512=:RK/0qy18MlBSVnWgjwz6lZEWjP/lF5HF9bvEF8FabDg=:'
        description: >
          Base64 encoded sha-512 hash of the http message body.


          This key isn't not required for `GET` and `DELETE` requests.


          [Learn how to generate content
          digest](/concepts/http-signature/content-digest)
      required: true
    XIdempotencyKey:
      in: header
      name: X-Idempotency-Id
      schema:
        type: string
        example: 01937261-e216-754f-99ba-c1170d65dd28
        description: >
          Unique identifier passed into each a mutable request (i.e `POST`,
          `PUT`, `PATCH`, `DELETE`)


          This key isn't not required for `GET` requests
      required: true
  schemas:
    UpdatePortfolio:
      type: object
      properties:
        portfolioId:
          $ref: '#/components/schemas/PortfolioId'
        currency:
          $ref: '#/components/schemas/Currency'
        status:
          $ref: '#/components/schemas/PortfolioStatus'
      required:
        - portfolioId
    Success:
      type: object
      properties:
        data:
          oneOf:
            - type: object
            - type: array
        code:
          $ref: '#/components/schemas/ResponseCode'
        message:
          $ref: '#/components/schemas/ResponseMessage'
      required:
        - data
        - code
        - message
    Portfolio:
      type: object
      description: An investment portfolio
      properties:
        portfolioId:
          $ref: '#/components/schemas/PortfolioId'
        accountId:
          $ref: '#/components/schemas/AccountId'
        customerId:
          $ref: '#/components/schemas/CustomerId'
        currency:
          $ref: '#/components/schemas/Currency'
        investmentAmount:
          $ref: '#/components/schemas/InvestmentAmount'
        marketValue:
          $ref: '#/components/schemas/MarketValue'
        performance:
          $ref: '#/components/schemas/Performance'
        status:
          $ref: '#/components/schemas/PortfolioStatus'
        createdAt:
          $ref: '#/components/schemas/CreatedAt'
        updatedAt:
          $ref: '#/components/schemas/UpdatedAt'
      required:
        - portfolioId
        - currency
        - investmentAmount
        - marketValue
        - performance
        - status
        - createdAt
        - updatedAt
    ClientId:
      description: Unique identifier assigned to the client
      type: string
      example: client-id
    PortfolioId:
      description: Unique portfolio identifier
      type: integer
      example: 123456
    Currency:
      description: Associated currency
      enum:
        - USD
        - EUR
        - ZK
      example: ZK
    PortfolioStatus:
      description: Current status of the portfolio
      enum:
        - ACTIVE
        - SUSPENDED
        - CLOSED
      example: ACTIVE
    ResponseCode:
      description: Request response code
      type: string
      example: 200
    ResponseMessage:
      description: Request response message
      type: string
      example: Success
    AccountId:
      description: Unique account identifier
      type: integer
      example: 123456
    CustomerId:
      description: Unique customer identifier
      type: integer
      example: 123456
    InvestmentAmount:
      description: The total amount invested into an asset or group of assets
      type: integer
      example: 1550
    MarketValue:
      description: The current market value of an asset or group of assets
      type: integer
      example: 11550
    Performance:
      description: >
        The performance of all the assets under the portfolio.


        This value is represented as a percentage increase or decrease over the
        lifetime of the portfolio
      type: integer
      example: 151
    CreatedAt:
      description: Created at unix timestamp
      type: integer
      example: 1234567890
    UpdatedAt:
      description: Updated at unix timestamp
      type: integer
      example: 1234567890
    Error:
      type: object
      properties:
        code:
          allOf:
            - $ref: '#/components/schemas/ResponseCode'
            - example: 401
        message:
          allOf:
            - $ref: '#/components/schemas/ResponseMessage'
            - example: Unauthorized
      required:
        - code
        - message
  responses:
    Unauthorized:
      description: Unauthorized
      content:
        application/json:
          schema:
            $ref: '#/components/schemas/Error'
    NotFound:
      description: The specified resource was not found
      content:
        application/json:
          schema:
            allOf:
              - $ref: '#/components/schemas/Error'
              - type: object
                properties:
                  code:
                    type: string
                    example: 404
                  message:
                    type: string
                    example: Not Found
  securitySchemes:
    BearerAuth:
      type: http
      scheme: bearer

````